-- Tabulka časové řady
CREATE TABLE USRBUF.TSP_BD_CONSUMPTION_TYPE 
(	
    OID NUMBER(22,0) NOT NULL, 
    BD_CONSUMPTION_TYPE NUMBER(22,0) NOT NULL, 
    FROM_TIME TIMESTAMP(6) NOT NULL, 
    TO_TIME TIMESTAMP(6) NOT NULL, 
    VAL_INTERNAL_ID NVARCHAR2(200), 
    VAL_S_INTERNAL_ID CHAR(1 BYTE) DEFAULT 'P' NOT NULL, 
    VAL_NAME NVARCHAR2(200), 
    VAL_S_NAME CHAR(1 BYTE) DEFAULT 'P' NOT NULL,
    VAL_SHORT_NAME NVARCHAR2(200), 
    VAL_S_SHORT_NAME CHAR(1 BYTE) DEFAULT 'P' NOT NULL
) 
COMPRESS NOLOGGING
TABLESPACE N_DAE_DATA;

-- B-tree index primárního klíče a integritní omezení
CREATE UNIQUE INDEX USRBUF.PK_TSP_BD_CONSUMPTION_TYPE 
ON USRBUF.TSP_BD_CONSUMPTION_TYPE (OID) 
TABLESPACE N_DAE_INDX
NOLOGGING;

ALTER TABLE USRBUF.TSP_BD_CONSUMPTION_TYPE 
ADD CONSTRAINT PK_TSP_BD_CONSUMPTION_TYPE 
PRIMARY KEY (OID)
USING INDEX USRBUF.PK_TSP_BD_CONSUMPTION_TYPE;

-- B-tree index unikátní kombinace klíče a integritní omezení
CREATE UNIQUE INDEX USRBUF.UQ_TSP_BD_CONSUMPTION_TYPE 
ON USRBUF.TSP_BD_CONSUMPTION_TYPE (TO_TIME, FROM_TIME, BD_CONSUMPTION_TYPE) 
TABLESPACE N_DAE_INDX
NOLOGGING;

ALTER TABLE USRBUF.TSP_BD_CONSUMPTION_TYPE 
ADD CONSTRAINT UQ_TSP_BD_CONSUMPTION_TYPE 
UNIQUE (TO_TIME, FROM_TIME, BD_CONSUMPTION_TYPE)
USING INDEX USRBUF.UQ_TSP_BD_CONSUMPTION_TYPE;

-- Pohled
CREATE OR REPLACE VIEW USRBUF.N_AF_CONSUMPTION_TYPE AS 
SELECT 
    OID AS CONSUMPTION_TYPE, 
    BD_CONSUMPTION_TYPE, 
    FROM_TIME, 
    TO_TIME,
    VAL_NAME AS NAME,
    VAL_S_NAME AS NAME_I,
    VAL_SHORT_NAME AS SHORT_NAME,
    VAL_S_SHORT_NAME AS SHORT_NAME_I,
    VAL_INTERNAL_ID AS INTERNAL_ID,
    VAL_S_INTERNAL_ID AS INTERNAL_ID_I
FROM TSP_BD_CONSUMPTION_TYPE
WHERE VAL_S_INTERNAL_ID != 'D';

COMMIT;