-- Tabulka časové řady
CREATE TABLE USRBUF.TSP_BD_RE 
(	
    OID NUMBER(22,0) NOT NULL, 
    BD_RE NUMBER(22,0) NOT NULL, 
    FROM_TIME TIMESTAMP(6) NOT NULL, 
    TO_TIME TIMESTAMP(6) NOT NULL, 
    VAL_INTERNAL_ID NVARCHAR2(200), 
    VAL_S_INTERNAL_ID CHAR(1 BYTE) DEFAULT 'P' NOT NULL, 
    VAL_NAME NVARCHAR2(200), 
    VAL_S_NAME CHAR(1 BYTE) DEFAULT 'P' NOT NULL, 
    VAL_DF_CODE NVARCHAR2(200), 
    VAL_S_DF_CODE CHAR(1 BYTE) DEFAULT 'P' NOT NULL,
    VAL_CODING_SCHEME NUMBER(22,0), 
    VAL_S_CODING_SCHEME CHAR(1 BYTE) DEFAULT 'P' NOT NULL
)
COMPRESS NOLOGGING
TABLESPACE N_DAE_DATA;

-- B-tree index primárního klíče a integritní omezení
CREATE UNIQUE INDEX USRBUF.PK_TSP_BD_RE 
ON USRBUF.TSP_BD_RE (OID) 
TABLESPACE N_DAE_INDX
NOLOGGING;

ALTER TABLE USRBUF.TSP_BD_RE 
ADD CONSTRAINT PK_TSP_BD_RE 
PRIMARY KEY (OID)
USING INDEX USRBUF.PK_TSP_BD_RE;

-- B-tree index unikátní kombinace klíče a integritní omezení
CREATE UNIQUE INDEX USRBUF.UQ_TSP_BD_RE 
ON USRBUF.TSP_BD_RE (TO_TIME, FROM_TIME, BD_RE) 
TABLESPACE N_DAE_INDX
NOLOGGING;

ALTER TABLE USRBUF.TSP_BD_RE 
ADD CONSTRAINT UQ_TSP_BD_RE 
UNIQUE (TO_TIME, FROM_TIME, BD_RE)
USING INDEX USRBUF.UQ_TSP_BD_RE;

-- Pohled
CREATE OR REPLACE VIEW USRBUF.N_AF_RE AS 
SELECT 
    OID AS RE,
    BD_RE, 
    FROM_TIME, 
    TO_TIME,
    VAL_NAME AS NAME,
    VAL_S_NAME AS NAME_I,
    VAL_CODING_SCHEME AS CODING_SCHEME,
    VAL_S_CODING_SCHEME AS CODING_SCHEME_I,
    VAL_INTERNAL_ID AS INTERNAL_ID,
    VAL_S_INTERNAL_ID AS INTERNAL_ID_I
FROM TSP_BD_RE
WHERE VAL_S_INTERNAL_ID != 'D';

COMMIT;