-- Tabulka časové řady
CREATE TABLE USRBUF.TSP_VAL_CONS_RE_PT15M 
(	
    OID NUMBER(22,0) NOT NULL, 
    OID_MGA NUMBER(22,0) NOT NULL,
    OID_RE NUMBER(22,0) NOT NULL,
    OID_CONSUMPTION_TYPE NUMBER(22,0) NOT NULL,
    OID_MEASUREMENT_TYPE NUMBER(22,0) NOT NULL,
    TO_TIME TIMESTAMP(6) NOT NULL, 
    VAL_QUANTITY NUMBER(20,7),
    VAL_S_QUANTITY CHAR(1 BYTE) DEFAULT 'P' NOT NULL,
    VAL_QUALITY NUMBER(22,0),
    VAL_S_QUALITY CHAR(1 BYTE) DEFAULT 'P' NOT NULL
)
NOLOGGING
TABLESPACE N_DAE_DATA 
PARTITION BY RANGE (TO_TIME) 
(
    PARTITION N_DAE_DATA_M_2021_1 VALUES LESS THAN (TIMESTAMP '2021-02-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE N_DAE_DATA_M_2021_1,
    PARTITION N_DAE_DATA_M_2021_2 VALUES LESS THAN (TIMESTAMP '2021-03-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE N_DAE_DATA_M_2021_2,
    PARTITION N_DAE_DATA_M_2021_3 VALUES LESS THAN (TIMESTAMP '2021-04-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE N_DAE_DATA_M_2021_3,
    PARTITION N_DAE_DATA_M_2021_4 VALUES LESS THAN (TIMESTAMP '2021-05-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE N_DAE_DATA_M_2021_4,
    PARTITION N_DAE_DATA_M_2021_5 VALUES LESS THAN (TIMESTAMP '2021-06-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE N_DAE_DATA_M_2021_5,
    PARTITION N_DAE_DATA_M_2021_6 VALUES LESS THAN (TIMESTAMP '2021-07-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE N_DAE_DATA_M_2021_6,
    PARTITION N_DAE_DATA_M_2021_7 VALUES LESS THAN (TIMESTAMP '2021-08-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE N_DAE_DATA_M_2021_7,
    PARTITION N_DAE_DATA_M_2021_8 VALUES LESS THAN (TIMESTAMP '2021-09-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE N_DAE_DATA_M_2021_8,
    PARTITION N_DAE_DATA_M_2021_9 VALUES LESS THAN (TIMESTAMP '2021-10-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE N_DAE_DATA_M_2021_9,
    PARTITION N_DAE_DATA_M_2021_10 VALUES LESS THAN (TIMESTAMP '2021-11-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE N_DAE_DATA_M_2021_10,
    PARTITION N_DAE_DATA_M_2021_11 VALUES LESS THAN (TIMESTAMP '2021-12-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE N_DAE_DATA_M_2021_11,
    PARTITION N_DAE_DATA_M_2021_12 VALUES LESS THAN (TIMESTAMP '2022-01-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE N_DAE_DATA_M_2021_12,
    PARTITION N_DAE_DATA_MAXVALUE VALUES LESS THAN (MAXVALUE) NOCOMPRESS TABLESPACE N_DAE_DATA_MAXVALUE
);

-- B-tree index primárního klíče a integritní omezení
CREATE UNIQUE INDEX USRBUF.PK_TSP_VAL_CONS_RE_PT15M ON USRBUF.TSP_VAL_CONS_RE_PT15M (OID, TO_TIME)
LOCAL
(
    PARTITION N_DAE_DATA_M_2021_1 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_1, 
    PARTITION N_DAE_DATA_M_2021_2 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_2, 
    PARTITION N_DAE_DATA_M_2021_3 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_3, 
    PARTITION N_DAE_DATA_M_2021_4 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_4, 
    PARTITION N_DAE_DATA_M_2021_5 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_5, 
    PARTITION N_DAE_DATA_M_2021_6 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_6, 
    PARTITION N_DAE_DATA_M_2021_7 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_7, 
    PARTITION N_DAE_DATA_M_2021_8 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_8, 
    PARTITION N_DAE_DATA_M_2021_9 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_9, 
    PARTITION N_DAE_DATA_M_2021_10 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_10, 
    PARTITION N_DAE_DATA_M_2021_11 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_11, 
    PARTITION N_DAE_DATA_M_2021_12 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_12, 
    PARTITION N_DAE_DATA_MAXVALUE NOCOMPRESS TABLESPACE N_DAE_INDX_MAXVALUE
)
NOLOGGING;

ALTER TABLE USRBUF.TSP_VAL_CONS_RE_PT15M 
ADD CONSTRAINT PK_TSP_VAL_CONS_RE_PT15M 
PRIMARY KEY (OID, TO_TIME)
USING INDEX USRBUF.PK_TSP_VAL_CONS_RE_PT15M;

-- B-tree index unikátní kombinace klíče a integritní omezení
CREATE UNIQUE INDEX USRBUF.UQ_TSP_VAL_CONS_RE_PT15M
ON USRBUF.TSP_VAL_CONS_RE_PT15M (TO_TIME, OID_MGA, OID_RE, OID_CONSUMPTION_TYPE, OID_MEASUREMENT_TYPE)
LOCAL
(
    PARTITION N_DAE_DATA_M_2021_1 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_1, 
    PARTITION N_DAE_DATA_M_2021_2 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_2, 
    PARTITION N_DAE_DATA_M_2021_3 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_3, 
    PARTITION N_DAE_DATA_M_2021_4 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_4, 
    PARTITION N_DAE_DATA_M_2021_5 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_5, 
    PARTITION N_DAE_DATA_M_2021_6 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_6, 
    PARTITION N_DAE_DATA_M_2021_7 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_7, 
    PARTITION N_DAE_DATA_M_2021_8 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_8, 
    PARTITION N_DAE_DATA_M_2021_9 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_9, 
    PARTITION N_DAE_DATA_M_2021_10 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_10, 
    PARTITION N_DAE_DATA_M_2021_11 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_11, 
    PARTITION N_DAE_DATA_M_2021_12 COMPRESS ADVANCED LOW TABLESPACE N_DAE_INDX_M_2021_12, 
    PARTITION N_DAE_DATA_MAXVALUE NOCOMPRESS TABLESPACE N_DAE_INDX_MAXVALUE
)
NOLOGGING;

ALTER TABLE USRBUF.TSP_VAL_CONS_RE_PT15M 
ADD CONSTRAINT UQ_TSP_VAL_CONS_RE_PT15M
UNIQUE (TO_TIME, OID_MGA, OID_RE, OID_CONSUMPTION_TYPE, OID_MEASUREMENT_TYPE)
USING INDEX USRBUF.UQ_TSP_VAL_CONS_RE_PT15M;

-- Bitmap index obchodních dimenzí
CREATE BITMAP INDEX USRBUF.BIT_TSP_VAL_CONS_RE_PT15M
ON USRBUF.TSP_VAL_CONS_RE_PT15M (OID_MGA, OID_RE, OID_CONSUMPTION_TYPE, OID_MEASUREMENT_TYPE)
LOCAL NOLOGGING TABLESPACE N_DAE_INDX;

-- Pohled
CREATE OR REPLACE VIEW USRBUF.N_AF_VAL_CONS_RE AS 
SELECT
    OID,
    TO_TIME - INTERVAL '15' MINUTE AS FROM_TIME,
    TO_TIME,
    OID_MGA AS MGA,
    OID_RE AS RE,
    OID_CONSUMPTION_TYPE AS CONSUMPTION_TYPE,
    OID_MEASUREMENT_TYPE AS MEASUREMENT_TYPE, 
    VAL_QUANTITY AS QUANTITY,
    VAL_QUALITY AS QUALITY
FROM TSP_VAL_CONS_RE_PT15M
WHERE VAL_S_QUANTITY != 'D';

COMMIT;