-- Tabulka časové řady
CREATE TABLE USRBUF.TS_14500000002085720 
(	
    OID NUMBER(22,0) NOT NULL, 
    T103TIME_UNIT_VALUE NUMBER(22,0) NOT NULL, 
    -- MGA
    BD_14500000002173483 NUMBER(22,0) NOT NULL,
    -- RE
    BD_14500000002173485 NUMBER(22,0) NOT NULL,
    -- CONSUMPTION_TYPE
    BD_14500000002173487 NUMBER(22,0) NOT NULL,
    -- MEASUREMENT_TYPE
    BD_14500000002173489 NUMBER(22,0) NOT NULL,
    FROM_TIME TIMESTAMP(6) NOT NULL, 
    TO_TIME TIMESTAMP(6) NOT NULL, 
    -- QUANTITY
    COMP_ERR_14500000002102116 NUMBER(1,0), 
    CORR_VALUE_14500000002102116 NUMBER(20,8), 
    TS_VALUE_14500000002102116 NUMBER(20,8),
    T406VALSTATE_14500000002102116 CHAR(1 BYTE),
    -- QUALITY
    COMP_ERR_14500000002102113 NUMBER(1,0), 
    CORR_VALUE_14500000002102113 NUMBER(17,0), 
    TS_VALUE_14500000002102113 NUMBER(17,0),
    T406VALSTATE_14500000002102113 CHAR(1 BYTE)
)
NOLOGGING
TABLESPACE O_DAE_DATA
PARTITION BY RANGE (TO_TIME) 
(
    PARTITION O_DAE_DATA_Q_2021_1 VALUES LESS THAN (TIMESTAMP '2021-04-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE O_DAE_DATA_Q_2021_1,
    PARTITION O_DAE_DATA_Q_2021_2 VALUES LESS THAN (TIMESTAMP '2021-07-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE O_DAE_DATA_Q_2021_2,
    PARTITION O_DAE_DATA_Q_2021_3 VALUES LESS THAN (TIMESTAMP '2021-10-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE O_DAE_DATA_Q_2021_3,
    PARTITION O_DAE_DATA_Q_2021_4 VALUES LESS THAN (TIMESTAMP '2022-01-01 00:00:00') ROW STORE COMPRESS ADVANCED TABLESPACE O_DAE_DATA_Q_2021_4,
    PARTITION O_DAE_DATA_MAXVALUE VALUES LESS THAN (MAXVALUE) NOCOMPRESS TABLESPACE O_DAE_DATA_MAXVALUE
);

-- B-tree index primárního klíče a integritní omezení
CREATE UNIQUE INDEX USRBUF.PK_14500000002085720 ON USRBUF.TS_14500000002085720 (OID, TO_TIME) 
LOCAL
(
    PARTITION O_DAE_DATA_Q_2021_1 COMPRESS ADVANCED LOW TABLESPACE O_DAE_INDX_Q_2021_1, 
    PARTITION O_DAE_DATA_Q_2021_2 COMPRESS ADVANCED LOW TABLESPACE O_DAE_INDX_Q_2021_2,
    PARTITION O_DAE_DATA_Q_2021_3 COMPRESS ADVANCED LOW TABLESPACE O_DAE_INDX_Q_2021_3,
    PARTITION O_DAE_DATA_Q_2021_4 COMPRESS ADVANCED LOW TABLESPACE O_DAE_INDX_Q_2021_4,
    PARTITION O_DAE_DATA_MAXVALUE NOCOMPRESS TABLESPACE O_DAE_INDX_MAXVALUE
)
NOLOGGING;

ALTER TABLE USRBUF.TS_14500000002085720 
ADD CONSTRAINT PK_14500000002085720 
PRIMARY KEY (OID, TO_TIME)
USING INDEX USRBUF.PK_14500000002085720;

-- B-tree index unikátní kombinace klíče a integritní omezení
CREATE UNIQUE INDEX USRBUF.UQ_14500000002085720_BD 
ON USRBUF.TS_14500000002085720 (TO_TIME, BD_14500000002173483, BD_14500000002173485, BD_14500000002173487, BD_14500000002173489)
LOCAL
(
    PARTITION O_DAE_DATA_Q_2021_1 COMPRESS ADVANCED LOW TABLESPACE O_DAE_INDX_Q_2021_1, 
    PARTITION O_DAE_DATA_Q_2021_2 COMPRESS ADVANCED LOW TABLESPACE O_DAE_INDX_Q_2021_2,
    PARTITION O_DAE_DATA_Q_2021_3 COMPRESS ADVANCED LOW TABLESPACE O_DAE_INDX_Q_2021_3,
    PARTITION O_DAE_DATA_Q_2021_4 COMPRESS ADVANCED LOW TABLESPACE O_DAE_INDX_Q_2021_4,
    PARTITION O_DAE_DATA_MAXVALUE NOCOMPRESS TABLESPACE O_DAE_INDX_MAXVALUE
)
NOLOGGING;

ALTER TABLE USRBUF.TS_14500000002085720 
ADD CONSTRAINT UQ_14500000002085720_BD 
UNIQUE (TO_TIME, BD_14500000002173483, BD_14500000002173485, BD_14500000002173487, BD_14500000002173489)
USING INDEX USRBUF.UQ_14500000002085720_BD;

-- Pohled
CREATE OR REPLACE VIEW USRBUF.O_AF_VAL_CONS_RE AS 
SELECT 
    OID,
    FROM_TIME,
    TO_TIME,
    BD_14500000002173483 AS MGA,
    BD_14500000002173485 AS RE,
    BD_14500000002173487 AS CONSUMPTION_TYPE,
    BD_14500000002173489 AS MEASUREMENT_TYPE, 
    TS_VALUE_14500000002102116 AS QUANTITY,
    T406VALSTATE_14500000002102116 AS QUANTITY_I,
    TS_VALUE_14500000002102113 AS QUALITY,
    T406VALSTATE_14500000002102113 AS QUALITY_I
FROM TS_14500000002085720
WHERE T406VALSTATE_14500000002102116 != 'D' OR T406VALSTATE_14500000002102116 IS NULL;

COMMIT;