-- Komprese tabulky
CREATE TABLE KNIHA
(
    NAZEV VARCHAR2(200) PRIMARY KEY,
    DATUM_VYDANI DATE NOT NULL
)
PARTITION BY RANGE(DATUM_VYDANI)
(
    PARTITION KNIHY_2021_LEDEN VALUES LESS THAN('01/02/2021')
    ROW STORE COMPRESS BASIC, -- Základní komprese
    PARTITION KNIHY_2021_UNOR VALUES LESS THAN('01/03/2021')
    ROW STORE COMPRESS ADVANCED, -- Pokročilá komprese
    PARTITION KNIHY_OSTATNI VALUES LESS THAN(MAXVALUE)
    NOCOMPRESS -- Bez komprese
);



-- Komprese indexu
CREATE INDEX INDEX_DATUM_VYDANI ON KNIHA(DATUM_VYDANI) 
COMPRESS 1; -- Základní komprese

CREATE INDEX INDEX_DATUM_VYDANI ON KNIHA(DATUM_VYDANI) 
COMPRESS ADVANCED LOW; -- Pokročilá komprese