# Popis obsahu externí přílohy
ZIP archív externí přílohy obsahuje následující složky.

## DataGenerator
Složka obsahuje zdrojový kód vytvořeného C# programu pro generování a vkládání dat do časových řad. Generování datových SQL skriptů je závislé na konfiguraci uložené v souboru „ModelConfig.json“. Přiložený konfigurační soubor vygeneruje datové skripty pouze pro 1 den. Pro účely testování byly vygenerovány skripty pro celý rok, tj. 365 dní. Důvodem pro omezení je fakt, že generované skripty pro celý rok vyžadují více než 8 GB diskové kapacity, což nemusí být chtěné. Omezení je možné upravit skrze parametr konfigurace „CountOfDays“. Výsledné skripty jsou generované do složky „output“ nacházející se ve stejné složce, jako spustitelný soubor programu. V debug módu se tedy skripty nachází defaultně na cestě „DataGenerator\bin\Debug\net5.0-windows\output“.

## Modely
Ve složce se nachází kompletní SQL skripty pro vytvoření a odstranění starého a nového datového modelu. Nachází se zde také soubor „schema.sql“, jež vytvoří schéma USRBUF. Každý model má vlastní UP a DOWN skript. UP skript vytvoří všechny potřebné tabulkové prostory a přidělí u nich potřebná práva schématu USRBUF. Po spuštění UP skriptu je možné vytvoření všech databázových objektů časových řad skrze jednotlivé skripty (BD, MEC_CONS_RE, VAL_CONS_RE). Pro oba modely existují navíc skripty na vytvoření hodnotových řad s pokročilou kompresí.

## Testy
Složka obsahuje všechny získané výsledky při srovnání obou modelů. Nachází se zde excelovský soubor „celkove_vysledky.xlsx“, který obsahuje souhrn všech důležitých metrik, jež jsou uvedeny v této práci. Ve složce jsou dostupné také uvedené dotazy a získané exekuční plány a statistiky dotazů.

## Příklady
Složka zahrnuje skripty, které byly uvedené v rámci práce jako příklady, tedy založení tabulek, indexů apod.